; Programm: PRG6b.ASM
LIST P=16C84
; Schreiben in den EEPROM-Daten-Speicher
; Dieses Programm soll in den EEPROM-Datenspeicher
; mit der EEPROM-Adresse 01h den Wert 0Fh 
; 'einschreiben'. Der Prozess soll erst nach
; vollstaendigen Beendigung des Schreibens weiter-
; gefuehrt werden.

; * Symboldefinition *
        W EQU 0
        f EQU 1
        STATUS_R EQU 03h
        EEDATA_R EQU 08h
        EEADR_R  EQU 09h
        INTCON_R EQU 0Bh
        OPTION_R EQU 81h
        TRIS_A   EQU 85h
        TRIS_B   EQU 86h
        EECON1_R EQU 88h
        EECON2_R EQU 89h

        #DEFINE Page_1 STATUS_R,5
        #DEFINE WR EECON1_R,1
        #DEFINE WREN EECON1_R,2
        #DEFINE EEIF EECON1_R,4
        

ORG 0000h
        GOTO Start

ORG 01FFh
        GOTO Start

ORG 0010h
Start   
        ; # Initialisierung des Prozessors
        CLRF    INTCON_R
                ; keine Interruptverarbeitung
        BSF     Page_1
                ; Registerseite 1 !
        CLRF    TRIS_A    
                ; Port_A als AUSgabe
        CLRF    TRIS_B
                ; Port_B als AUSgabe
        CLRF    OPTION_R
                ; Timereingang auf fosc/4
                ; kein Vorteiler
        CLRF    EEDATA_R
                ; Loeschen des EEDATA-Registers
                ; (ideal fr Simulation)
        CLRF    EEADR_R
                ; Loeschen des EEADR-Registers
                ; (ideal fr Simulation)
        CLRF    EECON1_R
                ; Loeschen des EECON1-Register
                ; (ideal fr Simulation)
        CLRF    EECON2_R
                ; Loeschen des EECON2-Register
                ; (ideal fr Simulation)
        BCF     Page_1
                ; Registerseite 0

        ; # Sezten des WREN-Bits in EECON1-Bit3
        ;   Punkt 1
        BSF     Page_1
        BSF     WREN
        BCF     Page_1

        ; # Schreiben des EEADR-Register
        ;   Punkt 2
        MOVLW   01h
        MOVWF   EEADR_R
        
        ; # Schreiben des EEDATA-Register
        ;   Punkt 3
        MOVLW   0Fh
        MOVWF   EEDATA_R

        ; # Initialisierungsprogramm
        ;   Punkt 4
        BSF     Page_1
        MOVLW   55h
        MOVWF   EECON2_R
                ; EECON2 mit Wert 055h schreiben
                ; Punkt 4 a
        MOVLW   0AAh
        MOVWF   EECON2_R
                ; EECON2 mit Wert 0AAh schreiben
                ; Punkt 4 b
        ; # Setzen des WRITE-Bits im EECON1
        BSF     WR
        BCF     Page_1

        ; # Warteschleife bis Datum in den EEPROM
        ;   geschrieben ist. Dieses wird mit 
        ;   Setzen des Interrupt-Flags EEIF
        ;   im EECON1 Bit 4 angezeigt. 
        ;   Softwaremaessiges Loeschen 
        ;   erforderlich!
        ;   Punkt 6
        BSF     Page_1
Schleif BTFSS   EEIF
          GOTO  Schleif
        BCF     EEIF
        BCF     Page_1

; * Endlosschleife
Marke   NOP
        GOTO    Marke

END
