#include <string.h>
#include <dos.h>
#include <process.h>
#include <iostream.h>
#include "wave.h"
#include "voc.h"

BYTE huge *Sound::SoundDaten,huge *Sound::Zeiger;
BYTE Sound::xlat[255],Sound::inc=1,Sound::StartWert=1,Sound::Zaehler=1;
DWORD Sound::count=0,Sound::Laenge=0;

Sound::Sound()
{
  TimerObject=new Timer();
}

Sound::~Sound()
{
  delete SoundDaten;
  delete TimerObject;
}

/* Diese Routine gibt die Daten im Puffer am Kanal 2 (Lautsprecher) des 8254
   aus */
void interrupt Sound::NeuerTimer(...)
{
  outportb(0x42,xlat[*Zeiger]); // Datenbyte gem Tabelle bersetzen und aus-
				// geben
  Zaehler--;
  if (!Zaehler) { count++; Zeiger+=inc; Zaehler=StartWert; }

  outportb(0x20,0x20);  // unspezifischer EOI-Befehl
}

/* Diese Prozedur erzeugt eine bersetzungstabelle fr die Daten, um die
   Abstnde zwischen den Punkten der Kurve zu erhhen */
void Sound::GenerateTab()
{
  float Step=float((1193180l/SampleRate & 0xf0)-0x1)/64;

  for (BYTE i=0;i<=128;i++) xlat[i]=0x1;
  for (i=128;i<255;i++)     xlat[i]=1193180l/SampleRate & 0xf0;
  for (i=0;i<=64;i++)       xlat[i+96]=i*Step+1;
}

// Anpassen der SampleRate, falls <1900 und >30000
void Sound::AdjustSampleRate()
{
  if (SampleRate>30000) { SampleRate/=2; Laenge/=2; inc=2; }
       // falls >30000 => halbe SampleFrequenz, nur jedes zweite Byte ausgeben
  while(SampleRate<19000)
  {
    SampleRate*=2;
    StartWert*=2;
  }                    // falls <19000, SampleFrequenz verdoppeln und jedes
}		       // Byte mehrmals ausgeben

/* Prozedur, die zwischen VOC- und WAVE-Dateien unterscheidet, und die je-
   weiligen Leseprozeduren aufruft; anschlieend Ausgabe der Daten */
char PlaySound(char *FileName)
{
  Sound *sp;

  if (strstr(FileName,".wav"))  sp=new Wave(FileName);
  else
  if (strstr(FileName,".voc"))  sp=new Voc(FileName);
  else ErrorMsg(NOFORM);    // falls die Endung nicht "voc" oder "wav" war,
			    // Fehlermeldung ausgeben und Programm abbrechen
//  if (!sp->Handle) ErrorMsg(NOFILE);

  char rueck=sp->Read();
  if (rueck) ErrorMsg(rueck);

  sp->Play();

  delete sp;
  return 0;
}

void Sound::Play()
{
  AdjustSampleRate(); // SampleRate anpassen, falls Frequenz < 19kHz oder > 30kHz
  GenerateTab();      // bersetzungstabelle erzeugen, um gengend groen Abstand zwischen

  TimerObject->Ein(Sound::NeuerTimer,SampleRate);  // Timer einschalten

  outportb(0x61,inportb(0x61) | 3); // Lautsprecher einschalten
  outportb(0x43,0x90);              // 8254: Kanal 2; nur LO-Byte laden;
				    //       Modus 0; Binrzhler;
  outportb(0x21,0xfe);
  outportb(0xa1,0xff);              // Alle IRQ's auer Timer sperren

  while(count<Laenge) {}           // wenn Ende erreicht ist, Schleife abbrechen

  outportb(0xa1,0x0);
  outportb(0x21,0x0);               // Alle IRQ's wieder freigeben

  TimerObject->Aus();                       // Timer wieder ausschalten

  outportb(0x61,inportb(0x61) & 0xfc); // Lautsprecher ausschalten
}

// Fehlermeldung ausgeben und Programm abbrechen
void ErrorMsg(char Nr)
{
  switch(Nr)
  {
    case NOVOC:  cerr << "Keine VOC-Datei !\n"; break;
    case NOMEM:  cerr << "Zuwenig Speicher, um Datei zu laden !\n"; break;
    case NORIFF: cerr << "Keine RIFF-Datei !\n"; break;
    case NOWAVE: cerr << "Keine WAVE-Datei !\n"; break;
    case NOFORM: cerr << "Unbekanntes Dateiformat !\n"; break;
    case NOFILE: cerr << "Fehler beim ffnen der Datei !\n"; break;
  }
  exit(Nr);
}

char Sound::Read()
{
  return 0;
}