#ifndef _SOUND_H
#include "sound.h"
#endif
#include "defs.h"

#define NOVOC  4            // Keine VOC-Datei

#define GetBlockLength(Val) (DWORD)Val[0]+       \
			    (DWORD)Val[1]*256+   \
			    (DWORD)Val[2]*65536l;  // Macro zum Errechnen der
						  // Blocklnge einer VOC-Datei

typedef struct
{
  BYTE FileID[20];       // "Creative Voice File\x1a"
  WORD OFFSound;         // immer 0x001a, da SoundDaten direkt nach Header
  WORD Version;          // Versions-Nummer: dzt 1.10
  WORD CodeVersion;      // Codierte Versions-Nummer
} VOCHEADER;

typedef struct
{
  char BlockTyp;         // dzt 9 verschiedene Blcke
  BYTE BlockLaenge[3];
} BLOCKHEADER;           // Die meisten Blcke besitzen diesen Header

typedef struct
{
  BYTE TimeConstant;     // Verschlsselte Sample-Frequenz
  char CompressionFlag;  // '0' = ungepackt, '1' = 2:1, '2' = 3:1, '3' = 4:1
} VOICE_DATA;            // Dieser Block MUSS vorhanden sein

typedef struct
{
  WORD SilenceDuration;  // Anzahl Null-Bytes, die im Puffer eingefgt werden
  WORD SampleRate;       // verschlsselte SampleFrequenz
} SILENCE_BLOCK;

typedef struct
{
  WORD MarkerNummer;
} MARKER;                // dient zur Synchronisation (z.B. mit Grafik)

typedef struct
{
  WORD RepeatValue;
} REPEAT_LOOP;          // Datenblcke zwischen REPEAT_LOOP und END_REPEAT
			// werden n+1 mal wiederholt.
typedef struct
{
  WORD TimeConstant;    // Verschlsselte SampleFrequenz
  char CompressionCode; // '0' = ungepackt, '1' = 2:1, '2' = 3:1, '3' = 4:1
  char Mode;            // '0' = Mono, '1' = Stereo
} EXTENDED;             // Die gleichen Daten in dem zwangsweise folgenden
			// VOICE_DATA Block werden ignoriert

class Voc : public Sound
{
  public:
    Voc(char *FileName);
    virtual ~Voc() {};

    virtual char Read();

  private:
    int Handle;
    char *FN;
};