#include <alloc.h>
#include <io.h>
#include <fcntl.h>
#include <mem.h>
#include <dos.h>
#include "wave.h"

Wave::Wave(char *FileName) : Sound()
{
  Handle=open(FileName,O_RDONLY | O_BINARY);
  if (Handle<0) ErrorMsg(NOFILE);

  FN=FileName;
}

// Leseprozedur fr WAVE-Dateien ...
char Wave::Read()
{
  HEADER Header;
  RIFF RIFFChunk;
  FMT  FMTChunk;
  DATA DATAChunk;
  BYTE huge *SoundDaten,huge *Zeiger;

  read(Handle,&RIFFChunk,sizeof(RIFF));  // RIFF-Chunk einlesen
  if (memicmp(&RIFFChunk.Header.Name,"RIFF",sizeof(FOURCC))) return NORIFF;
  if (memicmp(&RIFFChunk.Type,"WAVE",sizeof(FOURCC))) return NOWAVE;
					 // berprfen, ob RIFF - WAVE - Datei
  read(Handle,&Header,sizeof(HEADER));   // Kopf des FMT-Chunks einlesen
  while (memicmp(Header.Name,"FMT ",sizeof(FOURCC)))
  {                                      // kein FMT-Chunk ...
    lseek(Handle,tell(Handle)+Header.Laenge,SEEK_SET);
    read(Handle,&Header,sizeof(HEADER)); // zum nchsten Chunk springen
  }
  read(Handle,&FMTChunk,sizeof(FMT));    // FMT-Chunk einlesen
  lseek(Handle,tell(Handle)+Header.Laenge-sizeof(FMT),SEEK_SET);
      // falls FMT-Chunk grer als normalerweise, zum nchsten Chunk springen
  read(Handle,&DATAChunk.Header,sizeof(HEADER));
  while (memicmp(DATAChunk.Header.Name,"DATA",sizeof(FOURCC)))
  {
    lseek(Handle,tell(Handle)+DATAChunk.Header.Laenge,SEEK_SET);
    read(Handle,&DATAChunk.Header,sizeof(HEADER));
  }  // Kopf des DATA-Chunks suchen und einlesen

  Zeiger=SoundDaten=(BYTE huge *)farmalloc(DATAChunk.Header.Laenge);
  if (!SoundDaten) return NOMEM;  // falls zuwenig Speicher, austeigen

  DWORD len=DATAChunk.Header.Laenge; // Inhalt des DATA-Chunks in Puffer lesen
  while (len>60000l)     // solange len grer als 60000, Schleife ausfhren
  {
    len-=60000l;
    read(Handle,Zeiger,60000u); // 60KB von Datei lesen
    Zeiger+=60000l;         // Pufferzeiger um 60000 erhhen
  }
  read(Handle,Zeiger,(unsigned)len); // Rest einlesen

  close(Handle);

  Zeiger=SoundDaten;

  if (FMTChunk.BitsPerSample>8)   // falls kein 8 Bit - Format
  {
    int huge *zeiger=(int huge *)SoundDaten; // 16 Bit Zeiger auf Puffer setzen

    while(long(FP_SEG(zeiger))*16+FP_OFF(zeiger)-
	  long(FP_SEG(SoundDaten))*16-FP_OFF(SoundDaten)
	  <DATAChunk.Header.Laenge)
    {
      *Zeiger=char(*zeiger>>8) ^ 0x80;  // Unteres Byte abschneiden und MSB
      zeiger++;                         // invertieren
      Zeiger++;
    }
    Zeiger=SoundDaten;
    DATAChunk.Header.Laenge/=2;         // Laenge anpassen
  }

  SetSoundSampleRate((unsigned)FMTChunk.SampleRate);
  SetSoundLength(DATAChunk.Header.Laenge);
  SetSoundBuffer(SoundDaten);

  return 0;
}